# Specifies the port number that sshd(8) listens on. The default is 22.
# Multiple options of this type are permitted. See also ListenAddress.
Port 22

# Specifies whether password authentication is allowed. The default is yes.
#
# At first, to install the ssh keys, via ssh-copy-id, we need to allow password
# authentication.
PasswordAuthentication no

# This keyword can be followed by a list of user name patterns, separated by
# spaces. If specified, login is allowed only for user names that match one of
# the patterns. Only user names are valid; a numerical user ID is not
# recognized. By default, login is allowed for all users. If the pattern takes
# the form USER@HOST then USER and HOST are separately checked, restricting
# logins to particular users from particular hosts. HOST criteria may
# additionally contain addresses to match in CIDR address/masklen format. The
# allow/deny directives are processed in the following order: DenyUsers,
# AllowUsers, DenyGroups, and finally AllowGroups.
#
# See PATTERNS in ssh_config(5) for more information on patterns.
AllowUsers {{ topology.roles[current_group_role].ssh.allow_users | join(" ") }}

# This keyword can be followed by a list of group name patterns, separated by
# spaces. If specified, login is allowed only for users whose primary group or
# supplementary group list matches one of the patterns. Only group names are
# valid; a numerical group ID is not recognized. By default, login is allowed
# for all groups. The allow/deny directives are processed in the following
# order: DenyUsers, AllowUsers, DenyGroups, and finally AllowGroups.
#
# See PATTERNS in ssh_config(5) for more information on patterns.
AllowGroups ssh-users

#------------------------------------------------------------------------------

# Specifies which address family should be used by sshd(8). Valid arguments are
# any (the default), inet (use IPv4 only), or inet6 (use IPv6 only).
AddressFamily inet

# Specifies whether TCP forwarding is permitted. The available options are yes
# (the default) or all to allow TCP forwarding, no to prevent all TCP
# forwarding, local to allow local (from the perspective of ssh(1)) forwarding
# only or remote to allow remote forwarding only. Note that disabling TCP
# forwarding does not improve security unless users are also denied shell
# access, as they can always install their own forwarders.
AllowTcpForwarding yes

# Specifies the file that contains the public keys used for user
# authentication. The format is described in the AUTHORIZED_KEYS FILE FORMAT
# section of sshd(8). Arguments to AuthorizedKeysFile accept the tokens
# described in the TOKENS section. After expansion, AuthorizedKeysFile is taken
# to be an absolute path or one relative to the user's home directory. Multiple
# files may be listed, separated by whitespace. Alternately this option may be
# set to none to skip checking for user keys in files. The default is
# ".ssh/authorized_keys .ssh/authorized_keys2".
AuthorizedKeysFile .ssh/authorized_keys

# Specifies whether challenge-response authentication is allowed. All
# authentication styles from login.conf(5) are supported. The default is yes.
ChallengeResponseAuthentication no

# Specifies the ciphers allowed. Multiple ciphers must be comma-separated. If
# the specified value begins with a '+' character, then the specified ciphers
# will be appended to the default set instead of replacing them. If the
# specified value begins with a '-' character, then the specified ciphers
# (including wildcards) will be removed from the default set instead of
# replacing them.
#
# The supported ciphers are:
#
#    3des-cbc
#    aes128-cbc
#    aes192-cbc
#    aes256-cbc
#    aes128-ctr
#    aes192-ctr
#    aes256-ctr
#    aes128-gcm@openssh.com
#    aes256-gcm@openssh.com
#    chacha20-poly1305@openssh.com
#
# The default is:
#
#    chacha20-poly1305@openssh.com,
#    aes128-ctr,aes192-ctr,aes256-ctr,
#    aes128-gcm@openssh.com,aes256-gcm@openssh.com
#
# The list of available ciphers may also be obtained using "ssh -Q cipher".
Ciphers aes256-ctr,aes192-ctr,aes128-ctr,chacha20-poly1305@openssh.com

# Sets a timeout interval in seconds after which if no data has been received
# from the client, sshd(8) will send a message through the encrypted channel to
# request a response from the client. The default is 0, indicating that these
# messages will not be sent to the client.
ClientAliveInterval 15

# Sets the number of client alive messages which may be sent without sshd(8)
# receiving any messages back from the client. If this threshold is reached
# while client alive messages are being sent, sshd will disconnect the client,
# terminating the session. It is important to note that the use of client alive
# messages is very different from TCPKeepAlive. The client alive messages are
# sent through the encrypted channel and therefore will not be spoofable. The
# TCP keepalive option enabled by TCPKeepAlive is spoofable. The client alive
# mechanism is valuable when the client or server depend on knowing when a
# connection has become inactive.
#
# The default value is 3. If ClientAliveInterval is set to 15, and
# ClientAliveCountMax is left at the default, unresponsive SSH clients will be
# disconnected after approximately 45 seconds.
ClientAliveCountMax 3

# Specifies whether compression is enabled after the user has authenticated
# successfully. The argument must be yes, delayed (a legacy synonym for yes) or
# no. The default is yes.
Compression yes

# Specifies whether remote hosts are allowed to connect to ports forwarded for
# the client. By default, sshd(8) binds remote port forwardings to the loopback
# address. This prevents other remote hosts from connecting to forwarded ports.
# GatewayPorts can be used to specify that sshd should allow remote port
# forwardings to bind to non-loopback addresses, thus allowing other hosts to
# connect. The argument may be no to force remote port forwardings to be
# available to the local host only, yes to force remote port forwardings to
# bind to the wildcard address, or clientspecified to allow the client to
# select the address to which the forwarding is bound. The default is no.
GatewayPorts no

# Gives the verbosity level that is used when logging messages from sshd(8).
# The possible values are: QUIET, FATAL, ERROR, INFO, VERBOSE, DEBUG, DEBUG1,
# DEBUG2, and DEBUG3. The default is INFO. DEBUG and DEBUG1 are equivalent.
# DEBUG2 and DEBUG3 each specify higher levels of debugging output. Logging
# with a DEBUG level violates the privacy of users and is not recommended.
LogLevel VERBOSE

# The server disconnects after this time if the user has not successfully
# logged in. If the value is 0, there is no time limit. The default is 120
# seconds.
LoginGraceTime 50s

# Specifies the available MAC (message authentication code) algorithms. The MAC
# algorithm is used for data integrity protection. Multiple algorithms must be
# comma-separated. If the specified value begins with a '+' character, then the
# specified algorithms will be appended to the default set instead of replacing
# them. If the specified value begins with a '-' character, then the specified
# algorithms (including wildcards) will be removed from the default set instead
# of replacing them.
#
# The algorithms that contain "-etm" calculate the MAC after encryption
# (encrypt-then-mac). These are considered safer and their use recommended. The
# supported MACs are:
#
#    hmac-md5
#    hmac-md5-96
#    hmac-sha1
#    hmac-sha1-96
#    hmac-sha2-256
#    hmac-sha2-512
#    umac-64@openssh.com
#    umac-128@openssh.com
#    hmac-md5-etm@openssh.com
#    hmac-md5-96-etm@openssh.com
#    hmac-sha1-etm@openssh.com
#    hmac-sha1-96-etm@openssh.com
#    hmac-sha2-256-etm@openssh.com
#    hmac-sha2-512-etm@openssh.com
#    umac-64-etm@openssh.com
#    umac-128-etm@openssh.com
#
# The default is:
#
#    umac-64-etm@openssh.com,umac-128-etm@openssh.com,
#    hmac-sha2-256-etm@openssh.com,hmac-sha2-512-etm@openssh.com,
#    hmac-sha1-etm@openssh.com,
#    umac-64@openssh.com,umac-128@openssh.com,
#    hmac-sha2-256,hmac-sha2-512,hmac-sha1
#
# The list of available MAC algorithms may also be obtained using "ssh -Q mac".
MACs hmac-sha2-512-etm@openssh.com,hmac-sha2-512,hmac-sha2-256-etm@openssh.com,hmac-sha2-256,hmac-sha1-etm@openssh.com,hmac-sha1

# Specifies the maximum number of authentication attempts permitted per
# connection. Once the number of failures reaches half this value, additional
# failures are logged. The default is 6.
MaxAuthTries 6

# Specifies the maximum number of concurrent unauthenticated connections to the
# SSH daemon. Additional connections will be dropped until authentication
# succeeds or the LoginGraceTime expires for a connection. The default is
# 10:30:100.
#
# Alternatively, random early drop can be enabled by specifying the three colon
# separated values start:rate:full (e.g. "10:30:60"). sshd(8) will refuse
# connection attempts with a probability of rate/100 (30%) if there are
# currently start (10) unauthenticated connections. The probability increases
# linearly and all connection attempts are refused if the number of
# unauthenticated connections reaches full (60).
MaxStartups 10

# When password authentication is allowed, it specifies whether the server
# allows login to accounts with empty password strings. The default is no.
PermitEmptyPasswords no

# Specifies the destinations to which TCP port forwarding is permitted. The
# forwarding specification must be one of the following forms:
#
#    PermitOpen host:port
#    PermitOpen IPv4_addr:port
#    PermitOpen [IPv6_addr]:port
#
# Multiple forwards may be specified by separating them with whitespace. An
# argument of any can be used to remove all restrictions and permit any
# forwarding requests. An argument of none can be used to prohibit all
# forwarding requests. The wildcard '*' can be used for host or port to allow
# all hosts or ports, respectively. By default all port forwarding requests are
# permitted.
#PermitOpen localhost:80

# Specifies whether root can log in using ssh(1). The argument must be yes,
# prohibit-password, forced-commands-only, or no. The default is
# prohibit-password.
#
# If this option is set to prohibit-password (or its deprecated alias,
# without-password), password and keyboard-interactive authentication are
# disabled for root.
#
# If this option is set to forced-commands-only, root login with public key
# authentication will be allowed, but only if the command option has been
# specified (which may be useful for taking remote backups even if root login
# is normally not allowed). All other authentication methods are disabled for
# root.
#
# If this option is set to no, root is not allowed to log in.
PermitRootLogin no

# Specifies whether ~/.ssh/environment and environment= options in
# ~/.ssh/authorized_keys are processed by sshd(8). Valid options are yes, no or
# a pattern-list specifying which environment variable names to accept (for
# example "LANG,LC_*"). The default is no. Enabling environment processing may
# enable users to bypass access restrictions in some configurations using
# mechanisms such as LD_PRELOAD.
PermitUserEnvironment no

# Specifies the file that contains the process ID of the SSH daemon, or none to
# not write one. The default is /var/run/sshd.pid.
PidFile /var/run/sshd.pid

# Specifies whether sshd(8) should print the date and time of the last user
# login when a user logs in interactively. The default is yes.
PrintLastLog yes

# Specifies whether sshd(8) should print /etc/motd when a user logs in
# interactively. (On some systems it is also printed by the shell,
# /etc/profile, or equivalent.) The default is yes.
PrintMotd no

# Specifies whether public key authentication is allowed. The default is yes.
PubkeyAuthentication yes

# Specifies whether sshd(8) should check file modes and ownership of the user's
# files and home directory before accepting login. This is normally desirable
# because novices sometimes accidentally leave their directory or files
# world-writable. The default is yes. Note that this does not apply to
# ChrootDirectory, whose permissions and ownership are checked unconditionally.
StrictModes yes

# Configures an external subsystem (e.g. file transfer daemon). Arguments
# should be a subsystem name and a command (with optional arguments) to execute
# upon subsystem request.
#
# The command sftp-server implements the SFTP file transfer subsystem.
#
# Alternately the name internal-sftp implements an in-process SFTP server. This
# may simplify configurations using ChrootDirectory to force a different
# filesystem root on clients.
#
# By default no subsystems are defined.
Subsystem sftp internal-sftp

# Gives the facility code that is used when logging messages from sshd(8). The
# possible values are: DAEMON, USER, AUTH, LOCAL0, LOCAL1, LOCAL2, LOCAL3,
# LOCAL4, LOCAL5, LOCAL6, LOCAL7. The default is AUTH.
SyslogFacility AUTH

# Specifies whether the system should send TCP keepalive messages to the other
# side. If they are sent, death of the connection or crash of one of the
# machines will be properly noticed. However, this means that connections will
# die if the route is down temporarily, and some people find it annoying. On
# the other hand, if TCP keepalives are not sent, sessions may hang
# indefinitely on the server, leaving "ghost" users and consuming server
# resources.
#
# The default is yes (to send TCP keepalive messages), and the server will
# notice if the network goes down or the client host crashes. This avoids
# infinitely hanging sessions.
#
# To disable TCP keepalive messages, the value should be set to no.
TCPKeepAlive no

# Specifies whether sshd(8) should look up the remote host name, and to check
# that the resolved host name for the remote IP address maps back to the very
# same IP address.
#
# If this option is set to no (the default) then only addresses and not host
# names may be used in ~/.ssh/authorized_keys from and sshd_config Match Host
# directives.
UseDNS no

# Specifies whether X11 forwarding is permitted. The argument must be yes or
# no. The default is no.
#
# When X11 forwarding is enabled, there may be additional exposure to the
# server and to client displays if the sshd(8) proxy display is configured to
# listen on the wildcard address (see X11UseLocalhost), though this is not the
# default. Additionally, the authentication spoofing and authentication data
# verification and substitution occur on the client side. The security risk of
# using X11 forwarding is that the client's X11 display server may be exposed
# to attack when the SSH client requests forwarding (see the warnings for
# ForwardX11 in ssh_config(5)). A system administrator may have a stance in
# which they want to protect clients that may expose themselves to attack by
# unwittingly requesting X11 forwarding, which can warrant a no setting.
#
# Note that disabling X11 forwarding does not prevent users from forwarding X11
# traffic, as users can always install their own forwarders.
X11Forwarding no
